# https://stackoverflow.com/questions/8918753/r-help-page-as-object
#. HTML
getHTML_help <- function(...){
    thefile <- help(...)
    capture.output(
      tools:::Rd2HTML(utils:::.getHelpFile(thefile))
    )
}

#. Plain text
getPlain_help <- function(...){
    thefile <- help(...)
    capture.output(
      tools:::Rd2txt(utils:::.getHelpFile(thefile))
    )
}

#. List
Rd2_list <- function(rd_file)
{
  names(rd_file) <- substring(sapply(rd_file,
                                     attr,
                                     'Rd_tag'),
                              2);

  tmp_args <- rd_file$arguments;

  rd_file$arguments <- NULL;

  tmp_rd <- lapply(rd_file,
                   unlist);

  tmp_rd <- lapply(tmp_rd,
                   paste,
                   collapse='');

  tmp_args <- tmp_args[sapply(tmp_args ,
                              attr,
                              'Rd_tag') == '\\item'];

  tmp_args <- lapply(tmp_args,
                     lapply,
                     paste,
                     collapse='');

  tmp_args <- lapply(tmp_args,
                     'names<-',
                     c('arg',
                       'description'));

  tmp_rd$arguments <- tmp_args;

  return(tmp_rd);
}

getHelp_List <- function(...)
{
  the_file <- help(...)
  rd <- utils:::.getHelpFile(the_file);
  Rd2_list(rd);
}

#.. Usage
#(myhelp <- getHelp_List('qplot', package='ggplot2'))
#(myhelp <- getHelp_List('bpca'))
#getHelp_List('bpca', "bpca")
#(myhelp <- getHelp_List('fdt'))
#(myhelp <- getHelp_List('fdt', 'fdth'))
#(myhelp <- getHelp_List('iris'))
#(myhelp <- getHelp_List('!='))
#(myhelp <- getHelp_List('%*%'))