#==================================================================================
# Orinal author: Jeroen Ooms
# Original code: https://stackoverflow.com/questions/8918753/r-help-page-as-object
# Adapted by   : Jos Cludio Faria
# Objective    : To supply the current necessity of the Tinn-R project
# Date         : 2023-05-19 20:17:57
#==================================================================================

TR_Rd_List <- function(rd_file,
                       slots=c('name',
                               'title',
                               'description'))
{
  names(rd_file) <- substring(sapply(rd_file,
                                     attr,
                                     'Rd_tag'),
                              2)

  waste_slots <- setdiff(names(rd_file),
                         slots)

  # Discard information from unnecessary slots
  rd_file[waste_slots] <- NULL

  rd_tmp <- lapply(rd_file,
                   unlist)

  rd_tmp <- lapply(rd_tmp,
                   paste,
                   collapse='')

  return(rd_tmp)
}

TR_Get_Help <- function(topic=NULL,
                        package=NULL,
                        slots=c('name',
                                'title',
                                'description'))
{
  if (!missing(topic) | !missing(package))
    {
     the_file <- help(topic=as.character(topic),
                      package=as.character(package))
 
     if (length(as.character(the_file)) > 0)
       rd <- utils:::.getHelpFile(the_file)
 
     if (exists('rd'))
       TR_Rd_List(rd,
                  slots)
    } 
}

