#=======================================================================
# Orinal author : Gabor Grothendieck
# Original code : R-help: Sep 23, 2013 at 2:55 PM
# Topic         : Re: Vector of char generated by Sys.getenv function
#               :     is not available when the package is loaded
# Adapted by    : Jos Cludio Faria
# Objective     : To supply the current necessity of the Tinn-R project
# Date          : 2023-02-20 00:45:05
#=======================================================================
.onLoad <- function(libname, 
                    pkgname)
{
  if(Sys.info()[['sysname']] == 'Windows'){
    tmp <- Sys.getenv('TEMP')
    sep <- '\\'
  } else {  
    tmp <- '/tmp'
    sep <- '/'
  }
    
  .paths <<- file.path(tmp,
                       'Tinn-R',
                       c('',                   #  1
                         'search.txt',         #  2
                         'objects.txt',        #  3
                         'file.R',             #  4
                         'selection.R',        #  5
                         'block.R',            #  6
                         'lines.R',            #  7
                         'reformat_input.R',   #  8
                         'reformat_output.R',  #  9
                         'mirrors.R',          # 10
                         'code_completion.txt' # 11
                         ),
                       fsep=sep)
}
