\name{TR_Obj_Describe}
\alias{TR_Obj_Describe}
\alias{TR_Get_Help}
\alias{Rd2_List}

\title{
  Get a descriptive list of an R object
}

\description{
  Describe a R object from the Rd (documentation) file.
}

\usage{
  TR_Get_Help(topic=NULL,
              package=NULL,
              slots=c('name',
                      'title',
                      'description'))

  TR_Rd_List(rd_file,
             slots=c('name',
                     'title',
                     'description'))
}

\arguments{
  \item{topic}{usually, a name or character string specifying the topic for which help is sought. A character string (enclosed in explicit single or double quotes) is always taken as naming a topic.
    If the value of topic is a length-one character vector the topic is taken to be the value of the only element. Otherwise topic must be a name or a reserved word (if syntactically valid) or character string.}
  \item{package}{a name or character vector giving the packages to look into for documentation, or NULL. By default, all packages whose namespaces are loaded are used. To avoid a name being deparsed use e.g. (pkg_ref) (see the examples).}
  \item{slots}{Which slots from the full documentation list should be returned. The default are the slots: 'name', 'title' and 'description'.}
  \item{rd_file}{An Rd (documentation) file.}
}

\value{
  A descriptive list of an R object.
}

\keyword{utilities}
