#. TR_Args_Description
#.. TO DEBUG
library(debug)
mtrace(TR_Args_Description)
mtrace.off()

TR_Args_Description(aov, path='./ad.txt')

res <- as.character(
{
 " formula: A formula specifying the model."
 ""
 "    data: A data frame in which the variables specified in the formula"
 "          will be found. If missing, the variables are searched for in"
 "          the standard way."
 ""
 "projections: Logical flag: should the projections be returned?"
 ""
 "      qr: Logical flag: should the QR decomposition be returned?"
 ""
 "contrasts: A list of contrasts to be used for some of the factors in"
 "          the formula. These are not used for any 'Error' term, and"
 "          supplying contrasts for factors only in the 'Error' term will"
 "          give a warning."
 ""
 "     ...: Arguments to be passed to 'lm', such as 'subset' or"
 "          'na.action'.  See 'Details' about 'weights'."
 ""
}
)

# https://rdrr.io/github/mrdwab/SOfun/src/R/helpExtract.R
# https://gist.github.com/mrdwab/7586769
#. Function_1
HelpExtract <- function(Function, section = "Usage", type = "m_code") {
  A <- deparse(substitute(Function))
  x <- capture.output(tools:::Rd2txt(utils:::.getHelpFile(utils::help(A)),
                                     options = list(sectionIndent = 0)))
  B <- grep("^_", x)                    ## section start lines
  x <- gsub("_\b", "", x, fixed = TRUE) ## remove "_\b"
  X <- rep(FALSE, length(x))
  X[B] <- 1
  out <- split(x, cumsum(X))
  out <- out[[which(sapply(out, function(x)
    grepl(section, x[1], fixed = TRUE)))]][-c(1, 2)]
  while(TRUE) {
    out <- out[-length(out)]
    if (out[length(out)] != "") { break }
  }

  switch(
    type,
    m_code = {
      before <- "```r"
      after <- "```"
      c(before, out, after)
    },
    s_code = {
      before <- "<<>>="
      after <- "@"
      c(before, out, after)
    },
    m_text = {
      paste("    ", out, collapse = "\n")
    },
    s_text = {
      before <- "\\begin{verbatim}"
      after <- "\\end{verbatim}"
      c(before, out, after)
    },
    stop("`type` must be either `m_code`, `s_code`, `m_text`, or `s_text`")
  )
}

#. Function_2
#.. Modificao para lidar com sees inexistentes?

helpExtract <- function(Function, section = "Usage", type = "m_code") {
  A <- deparse(substitute(Function))
  x <- capture.output(tools:::Rd2txt(utils:::.getHelpFile(utils::help(A)),
                                     options = list(sectionIndent = 0)))
  B <- grep("^_", x)                      ## section start lines
  x <- gsub("_\b", "", x, fixed = TRUE)   ## remove "_\b"
  X <- rep(FALSE, length(x))              ## Create a FALSE vector
  X[B] <- 1                               ## Initialize
  out <- split(x, cumsum(X))              ## Create a list of sections
  sectionID <- vapply(out, function(x)    ## Identify where the section starts
    grepl(section, x[1], fixed = TRUE), logical(1L))

  if (!any(sectionID)) {                  ## If the section is missing...
    ""                                    ## ... just return an empty character
  } else {                                ## Else, get that list item
    out <- out[[which(sectionID)]][-c(1, 2)]
    while(TRUE) {                         ## Remove the extra empty lines
      out <- out[-length(out)]            ##   from the end of the file
      if (out[length(out)] != "") { break }
    }

    switch(                               ## Determine the output type
      type,
      m_code = {
        before <- "```r"
        after <- "```"
        c(before, out, after)
      },
      s_code = {
        before <- "<<eval = FALSE>>="
        after <- "@"
        c(before, out, after)
      },
      m_text = {
        paste("    ", out, collapse = "\n")
      },
      s_text = {
        before <- "\\begin{verbatim}"
        after <- "\\end{verbatim}"
        c(before, out, after)
      },
      stop("`type` must be either `m_code`, `s_code`, `m_text`, or `s_text`")
    )
  }
}

#. Function_1: melhoramentos
fHelp_Extract <- function(object,
                          pkg=NULL,
                          section='Arguments',
                          type='m_code')
{
  object <- deparse(substitute(object))
  pkg_ref <- pkg  // # See help(help) last example

  x <- capture.output(tools:::Rd2txt(utils:::.getHelpFile(utils::help(topic=object,
                                                                      (pkg_ref)))),
                                     options=list(sectionIndent=0))
  ## section start lines
  B <- grep('^_',
            x)

  ## remove '_\b'
  x <- gsub('_\b',
            '',
            x,
            fixed = TRUE)

  X <- rep(FALSE,
           length(x))

  X[B] <- 1

  out <- split(x,
               cumsum(X))

  out <- out[[which(sapply(out,
                           function(x)
    grepl(section,
          x[1],
          fixed = TRUE)))]][-c(1, 2)]

  while(TRUE) {
    out <- out[-length(out)]
    if (out[length(out)] != '') { break }
  }

  switch(
    type,
    m_code = {
      before <- '```r'
      after <- '```'
      c(before,
        out,
        after)
    },
    s_code = {
      before <- '<<>>='
      after <- '@'
      c(before,
        out,
        after)
    },
    m_text = {
      paste('    ',
            out,
            collapse = '\n')
    },
    s_text = {
      before <- '\\begin{verbatim}'
      after <- '\\end{verbatim}'
      c(before,
        out,
        after)
    },
    stop('`type` must be either `m_code`, `s_code`, `m_text`, or `s_text`')
  )
}

#. Function_2: melhoramentos
fhelp_Extract <- function(object,
                          pkg=NULL,
                          section='Arguments')
{
  object <- deparse(substitute(object))
  pkg_ref <- pkg  # See help(help) last example

  x <- capture.output(tools:::Rd2txt(utils:::.getHelpFile(utils::help(topic=object,
                                                                      (pkg_ref))),
                                     options=list(sectionIndent=0)))
  B <- grep('^_',
            x)                                ## section start lines
  x <- gsub('_\b',
            '',
            x,
            fixed=TRUE)                       ## remove '_\b'
  X <- rep(FALSE,
           length(x))                         ## Create a FALSE vector
  X[B] <- 1                                   ## Initialize
  out <- split(x,
               cumsum(X))                     ## Create a list of sections
  sectionID <- vapply(out,
                      function(x)             ## Identify where the section starts
    grepl(section, x[1],
          fixed=TRUE),
          logical(1L))

  if (!any(sectionID)) {                      ## If the section is missing...
    ''                                        ## ... just return an empty character
  } else {                                    ## Else, get that list item
    out <- out[[which(sectionID)]][-c(1, 2)]
    while(TRUE) {                             ## Remove the extra empty lines
      out <- out[-length(out)]                ##   from the end of the file
      if (out[length(out)] != '') { break }
    }

  return(out)
  }
}

#. Learning
p_load(fdth)
utils:::.getHelpFile(utils::help(sd))
utils:::.getHelpFile(utils::help(sd,
                                 package=fdth))
utils:::.getHelpFile(utils::help(sd,
                                 package=stats))

p_unload(fdth)
utils:::.getHelpFile(utils::help(sd))
tools:::Rd2txt(utils:::.getHelpFile(utils::help(sd)))
r1 <- utils:::.getHelpFile(utils::help(sd,
                                       package=stats))
str(r1) # HARD Rd tags
print(r1)
x <- capture.output(tools:::Rd2txt(r1))
B <- grep("^_", x)                    ## section start lines
x <- gsub("_\b", "", x, fixed = TRUE) ## remove "_\b"
X <- rep(FALSE, length(x))
X[B] <- 1
out <- split(x, cumsum(X))

section <- 'arguments'
out <- out[[which(sapply(out, function(x)
  grepl(section, x[1], fixed = TRUE)))]][-c(1, 2)]
while(TRUE) {
  out <- out[-length(out)]
  if (out[length(out)] != "") { break }
}

#. Tests
library(fdth)
fHelp_Extract(scan)
fhelp_Extract(scan)
fhelp_Extract(read.table)

fHelp_Extract(sd)  # ERRO! OK
fhelp_Extract(sd)  # ERRO! OK

fHelp_Extract(sd,
              pkg='stats')
fhelp_Extract(sd,
              pkg='stats')

fHelp_Extract(sd,
              pkg='fdth')
fhelp_Extract(sd,
              pkg='fdth')

#.. Changing section
'Description'
'Usage'
'Arguments'
'Details'
'See Also'
'Examples'

#... iris
fhelp_Extract(iris,
              section='Description')

fhelp_Extract(iris,
              section=c('Usage'))

fhelp_Extract(iris,
              section='Arguments')

fhelp_Extract(iris,
              section='Details')

fhelp_Extract(iris,
              section='See Also')

fhelp_Extract(iris,
              section='Examples')

#... fdt
fhelp_Extract(sd,
              pkg='fdth',
              section='Description')

fhelp_Extract(sd,
              pkg='fdth',
              section='Usage')

fhelp_Extract(sd,
              pkg='fdth',
              section='Arguments')

fhelp_Extract(sd,
              pkg='fdth',
              section='Details')

fhelp_Extract(sd,
              pkg='fdth',
              section='See Also')

fhelp_Extract(sd,
              pkg='fdth',
              section='Examples')

#. Comparativo

TR_Args('scan')

fHelp_Extract(scan,
              section="Arguments",
              type='s_code')

library(fdth)
TR_Code_Completion('^var')

fHelp_Extract(var,
              section="arguments",
              type='s_code')


#. Resilincia!
# Funo simples
fmy_fun <- function(obj,
                    pck=NULL)
  res <- list(obj=obj,
              pck=pck,
              help=utils::help(topic=eval(obj),
                               package=eval(pck))
              )
  return(res)
}

#.. Help directaly
help(topic=sd,
     package=stats)
# OK

help(topic=deparse(substitute(sd)),
     package=deparse(substitute(stats)))
# OK

pk <- quote(ssss)
help(topic=sd,
     package=pk)

pk <- packages:::stats
help(topic=deparse(substitute(sd)),
     package=pk)

#.. Help by fmy_fun
test <- fmy_fun('sd')
#OK

test <- fmy_fun(sd)
test
#OK

test <- fmy_fun('sd',
                'stats')

test <- fmy_fun('sd',
                 'fdth')

test <- fmy_fun(sd,
                stats)
test

#. quote, substitute, eval
# https://stackoverflow.com/questions/46834655/whats-the-difference-between-substitute-and-quote-in-r
f <- function(arg_X,
              arg_Y=NULL)
{
  list(# arg_X
       'quote_X:' = quote(arg_X),
       'substitute_X:' = substitute(arg_X),
       'deparse(substitute_X):' = deparse(substitute(arg_X)),
       'eval_X:' = eval(substitute(arg_X)),
       'arg_X:' = arg_X,

       # arg_Y
       'quote_Y:' = quote(arg_Y),
       'substitute_Y:' = substitute(arg_Y),
       'deparse(substitute_Y):' = deparse(substitute(arg_Y)),
       'eval_Y:' = eval(substitute(arg_Y)),
       'arg_Y:' = arg_Y
       )
}

sup_ArgX <- 100
f(sup_ArgX)

f(sup_ArgX,
  sd)

f(sup_ArgX,
  stats)

sup_ArgY <- 1
f(sup_ArgX,
  sup_ArgY)

#. deparse(substitute(arg))
ftes <- function(a1,
                 a2=NULL)
{
  a1 <- deparse(substitute(a1))
  cat(a1,
      '\n')

  a2 <- deparse(substitute(a2))
  cat(a2,
    '\n')
}

ftes(a)
ftes(aa)
ftes(sd)

ftes(b)
a1 <- 'b'
deparse(substitute(a1))
