#. Pipe operators
%>%
%<>%
%$%
%T>%
|>

#. Examples colected from example of magrittr package
#.. %>%
# Basic use:
iris |>
 head(3)

iris %>%
 head

iris %>%

 head

iris %>%
 #lkjlkjlk
 head

# Using the dot place-holder
"Ceci n'est pas une pipe" %>%
 gsub("une", "un", .)

# When dot is nested, lhs is still placed first:
sample(1:10) %>%
 paste0(LETTERS[.])

# Lambda expressions:
iris %>%
{
  size <- sample(1:10, size = 1)
  rbind(head(., size), tail(., size))
}

# renaming in lambdas:
iris %>%
{
  my_data <- .
  size <- sample(1:10, size = 1)
  rbind(head(my_data, size), tail(my_data, size))
}

# Building unary functions with %>%
trig_fest <- . %>%
 tan %>%
 cos %>%
 sin

1:10 %>%
 trig_fest

#.. %<>%
iris$Sepal.Length %<>%
 sqrt

x %<>%
 abs %>%
 sort

#.. %$%
iris %>%
  subset(Sepal.Length > mean(Sepal.Length)) %$%
  cor(Sepal.Length, Sepal.Width)

data.frame(z = rnorm(100)) %$%
  ts.plot(z)

#.. %T>%
rnorm(200) %>%
  matrix(ncol = 2) %T>%
  plot %>% # plot usually does not return anything.
  colSums

#. Examples colected from web
iris %>%
  arrange(Species)

iris %>%
  group_by(Species) %>%
  summarize_if(is.numeric, mean) %>%
  ungroup() %>%
  gather(measure, value, -Species) %>%
  arrange(value)

iris_long <- iris %>%
  gather(measure, value, -Species) %>%
  arrange(-value)

iris %>%
{
  size <- sample(1:10, size = 1)
  rbind(head(., size), tail(., size))
}

# renaming in lambdas:
iris %>%
{
  my_data <- .
  size <- sample(1:10,
                 size = 1)
  rbind(head(my_data, size),
        tail(my_data, size))
}

rnorm(100) %>%
{
 c(min(.),
   mean(.),
   max(.))
} %>% floor

# This can be avoided:
x %>%
  select(a, b, w) %>%
  left_join(y %>% select(a, b, v), by = c("a", "b"))

rnorm(1000)    %>%
  multiply_by(5) %>%
  add(5)         %>%
  {
    cat("Mean:", mean(.),
        "Variance:", var(.), "\n")
    head(.)
  }

#. UFFFAAA
rnorm(1e2,
      m=10,
      sd=2) %>%
  mean %>%
  round(2)

rnorm(1e2,
      m=10,

      #asdfas
      sd=2) %>%
  mean %>%
  round(2)

iris_long <-
  iris %>%
  gather(measure,
         value,
         -Species) %>%
  arrange(-value)

is_weekend <- function(day)
{
   day %<>% as.Date
   result <- day %>%
             format("%u") %>%
             as.numeric %>%
             is_greater_than(5)
   if (result)
     message(day %>%
             paste("is a weekend!"))
   else
     message(day %>%
             paste("is not a weekend!"))
   invisible(result)
}

is_weekend <- function(day)
{

   # Coment
   day %<>% as.Date
   result <- day %>%                     #? acceptable!
             format("%u") %>%            #? acceptable!
             as.numeric %>%              #? acceptable!
             is_greater_than(5)          #? acceptable!
   if (result)                           #? acceptable!
     message(day %>%                     #? acceptable!
             paste("is a weekend!"))     #? acceptable!
   else                                  #? acceptable!
     message(day %>%                     #? acceptable!
             paste("is not a weekend!")) #? acceptable!
                                         #? acceptable!
   invisible(result)
}

car_data <-
  mtcars %>%
  subset(hp > 100) %>%
  aggregate(. ~ cyl,
            data = .,

            FUN = . %>%      #? acceptable!
                             #? acceptable!
            #adsfasdf        #? acceptable!
            mean %>%         #? acceptable!
            round(2)) %>%
  transform(kpl = mpg %>%

            #asdfasdf
            multiply_by(0.4251)) %>%
  print

iris %>%
 group_by(Species) %>%
 summarise(
   Sepal.Length = mean(Sepal.Length),
   #asdfasdf asdf
   Sepal.Width = mean(Sepal.Width),     #? acceptable!
                                        #? acceptable!
   Species = n_distinct(Species)        #? acceptable!
)

iris %>%
  gather(measure, value, -Species) %>%
  arrange(-value) ->
  iris_long

iris_long <-

  #?
  iris %>%                   #? acceptable!
  test %>%                   #? acceptable!
  gather(measure,            #? acceptable!
         value,              #? acceptable!
         -Species) %>%       #? acceptable!
  arrange(-value)            #? acceptable!
                             #? acceptable!

#.Excees
x_join <- x %>%
 select(a, b, w)
y_join <- y %>%
 select(a, b, v)
left_join(x_join, y_join, by = c("a", "b"))

